Foreman - Bug #10340

AD auth hangs while syncing user groups on login
04/30/2015 04:05 PM - Vasil Mikhalenya

Status: Closed

Priority: Normal

Assignee: Mathieu Parent

Category: Authentication

Target version: 1.9.1

Difficulty: Fixed in Releases:

Triaged: Found in Releases: 1.8.0
Bugzilla link: Red Hat JIRA:

Pull request:

Description

Please look at
https://github.com/theforeman/foreman/commit/01{f8b024199f3bb2951ba1e7fe98959{74b9f3a4#commitcomment-10992439

user.auth_source.update_usergroups(login) broke AD auth for my case, after auth nothing happens just infinite traffic between
foreman an AD

auth worked on 1.7.4

commenting this line fix the issue

Related issues:

Related to Foreman - Bug #7369: External user groups should be updated on login Closed 09/05/2014
Related to Foreman - Bug #10493: LDAP broken in 1.8 with $login in account name Closed 05/13/2015
Related to Foreman - Feature #10509: Ability to disable syncing external user... Closed 05/14/2015
History

#1 - 04/30/2015 04:06 PM - Vasil Mikhalenya

caused by http:/projects.theforeman.org/issues/7369

#2 - 05/01/2015 03:16 AM - Dominic Cleal
- Related to Bug #7369: External user groups should be updated on login added

#3 - 05/01/2015 03:17 AM - Dominic Cleal

Does the refresh button on your external user groups also just hang?

#4 - 05/01/2015 04:36 AM - Vasil Mikhalenya

I have no idea how should it works because we use only one group in AD and use it in Idap filter.
Seems it fails in different way:
I've added group, tried to add mapping to AD it fails with "POST /usergroups/1-admins HTTP/1.1" 500"

Started PUT "/usergroups/1-admins" for 10.128.60.25 at 2015-05-01 08:26:17 +0000

2015-05-01 08:26:17 [I] Processing by UsergroupsController#update as HTML

2015-05-01 08:26:17 [I] Parameters: {"utf8"=>"Ll", "authenticity_token"=>"............... blanked..........ccccoeeenee ", "usergroup"=>{"name"=>"admins",
"user_ids"=>[""], "admin"=>"1", "role_ids"=>["", "9"], "external_usergroups_attributes"=>{"0"=>{"_destroy"=>"false", "name"=>"Server Administration
Team", "auth_source_id"=>"2"}, "new_external_usergroups"=>{"_destroy"=>"false", "name"=>"", "auth_source_id"=>"2"}}}, "commit"=>"Submit",
"id"=>"1-admins"}

2015-05-01 08:26:17 [I]

But it had been added because item and button appeared. When | click refresh button - get this
LdapFluff::ActiveDirectory::MemberService::UIDNotFoundException
LdapFluff::ActiveDirectory::MemberService::UIDNotFoundException
app/models/auth_sources/auth_source_ldap.rb:114:in "users_in_group'
app/models/external_usergroup.rb:32:in “users'

app/models/external_usergroup.rb:18:in “refresh’
app/controllers/external_usergroups_controller.rb:5:in “refresh’
app/controllers/concerns/application_shared.rb:13:in “set_timezone'
app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'
https://github.com/theforeman/foreman/commit/01f8b024199f3bb2951ba1e7fe98959f74b9f3a4#commitcomment-10992439
http://projects.theforeman.org/issues/7369

lib/middleware/catch_json_parse_errors.rb:9:in “call'
the same for rake task

[v-foreman ~J# foreman-rake Idap:refresh_usergroups

Apipie cache enabled but not present yet. Run apipie:cache rake task to speed up API calls.
Workaround for RoVmomi may not work as ComputeResource is already loaded: ComputeResource
User group Server Administration Team could not be refreshed - LDAP source LDAP-v-dc not available:
LdapFluff::ActiveDirectory::MemberService::UIDNotFoundException

#5 - 05/13/2015 08:54 AM - Dominic Cleal

- translation missing: en.field_release set to 50

#6 - 05/13/2015 08:54 AM - Dominic Cleal
- Related to Bug #10493: LDAP broken in 1.8 with $login in account name added

#7 - 05/14/2015 08:09 AM - Dominic Cleal

- Subject changed from AD auth stops working on 1.8 to AD auth hangs while syncing user groups on login

#8 - 05/14/2015 08:10 AM - Dominic Cleal
- Related to Feature #10509: Ability to disable syncing external user groups on login added

#9 - 05/14/2015 11:10 AM - Dominic Cleal
#10509 will provide a workaround by disabling this feature, but | don't understand yet why it's hanging.

If you have the ability to install a nightly version of Foreman on a test server, please do so and enable debugging (
http://projects.theforeman.org/projects/foreman/wiki/Troubleshooting#How-do-I-enable-debugging) as nightly builds now have LDAP debugging. It
might show us what it's attempting to do.

#10 - 05/18/2015 03:03 PM - Tom Sherrod

I've installed the latest via git clone, Version 1.9.0-develop.

Enabled debug.

Created the Idap, with one group.

With User Sync off, able to log in, however, have to do a group refresh before user as access.

With User Sync enabled, logging in hangs. LDAP-op search loops in a set of groups. Another user attempted to login with same result with a different
group looping. Recovery is to kill the process.

#11 - 05/19/2015 08:13 AM - Dominic Cleal

What layout are those groups Tom? Is one a member of the other?

#12 - 05/19/2015 11:08 PM - Tom Sherrod

Not sure what you mean by layout. The groups are owners of other multiple groups the id is a member of so the group is repeated a couple of times
using powershell to list out the groups, recursively. They are not direct members of each other, however, with this many groups(~180) it may be
possible.

#13 - 05/20/2015 02:25 AM - Dominic Cleal

- translation missing: en.field_release changed from 50 to 56

#14 - 06/15/2015 05:17 AM - Dominic Cleal

- translation missing: en.field_release deleted (56)

#15 - 07/21/2015 08:46 AM - Mathieu Parent

Hello,

This fixes it for me: https://github.com/theforeman/Idap_fluff/pull/43

#16 - 07/27/2015 04:18 AM - Dominic Cleal
- Status changed from New to Closed
- % Done changed from 0 to 100

- translation missing: en.field_release set to 62

#17 - 08/06/2015 10:17 AM - Dominic Cleal
- Status changed from Closed to Ready For Testing
- % Done changed from 100 to 50

- translation missing: en.field_release deleted (62)

https://github.com/theforeman/Ildap_fluff/pull/44 contains a further fix | think to prevent the hang.

#18 - 08/20/2015 05:05 AM - Vasil Mikhalenya

in 1.9.0 issue still exists but unchecking 'Usergroup sync' make it work

#19 - 09/09/2015 01:43 AM - Mathieu Parent
The loop has been fixed in https:/github.com/theforeman/Idap_fluff/pull/43 and https://github.com/theforeman/Ildap_fluff/pull/44.

But this is not the end of the story. If your logins are not lowercase, your groups will be considered empty. this should be solved on the foreman side.
Also, as performance of ActiveDirectory is very low, an option do disable recursive search would be better.

| will try to work on those, but I'm very busy currently.

#20 - 09/09/2015 03:30 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- Assignee set to Mathieu Parent

- % Done changed from 50 to 100

- translation missing: en.field_release set to 72

Mathieu Parent wrote:

The loop has been fixed in https:/github.com/theforeman/Idap_fluff/pull/43 and https://github.com/theforeman/ldap_fluff/pull/44.

But this is not the end of the story. If your logins are not lowercase, your groups will be considered empty. this should be solved on the foreman
side.

You're in luck, Daniel has just been fixing this. | think #11428 and #11407 should fix case insensitivity for both groups and logins.
